using System;
using System.Data;
using MySql.Data.MySqlClient;

namespace FunTonn.MySqlDAL.SqlUtility {

    internal sealed class DataReadyUtility {

        public static string GetString(MySqlDataReader reader, int columnIndex) {
            if (reader.IsDBNull(columnIndex))
                return null;
            return reader.GetString(columnIndex);
        }

        public static int? GetInt32(MySqlDataReader reader, int columnIndex) {
            if (reader.IsDBNull(columnIndex))
                return null;
            return reader.GetInt32(columnIndex);
        }

        public static DateTime? GetDateTime(MySqlDataReader reader, int columnIndex) {
            if (reader.IsDBNull(columnIndex))
                return null;
            return reader.GetDateTime(columnIndex);
        }


    }
}
