using System;
using System.Collections.Generic;
using System.Text;

namespace FunTonn.MySqlDAL.SqlUtility {

    /// <summary>
    /// ṩһ࣬ṩ2ӷ
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public abstract class JoinTableAccess<T> : ReadonlyTableAccess<T> {

        protected const char MAIN_TABLE_ALIAS = 'm';
        protected const char SUB_TABLE_ALIAS = 's';

        /// <summary>
        /// ȡʶ
        /// </summary>
        abstract internal IReadonlyTableAccess MainTableDAL { get;}

        /// <summary>
        /// ȡӱʶ
        /// </summary>
        abstract internal IReadonlyTableAccess SubTableDAL { get;}

        /// <summary>
        /// ȡݱӷʽ
        /// join, inner join
        /// </summary>
        virtual protected string JoinCommand {
            get { return "join"; }
        }


        public override string TableName {
            get {
                // ¸ʽַ
                // {0}      {1} {6} {2}     {3}  {1}{4}         {3}{5}
                // maintable m join subtable s on m.primaryKey = s.primaryKey
                return string.Format(
                    "{0} {1} {6} {2} {3} on {1}.{4}={3}.{5} ",
                    MainTableDAL.TableName,
                    MAIN_TABLE_ALIAS,
                    SubTableDAL.TableName,
                    SUB_TABLE_ALIAS,
                    MainTableDAL.TablePrimaryColumn.Name,
                    SubTableDAL.TablePrimaryColumn.Name,
                    JoinCommand
                    );
            }
        }

        public override TableColumnCollection TableColumns {
            get {
                // ֶ
                TableColumnCollection mainColumns = MainTableDAL.TableColumns;
                // ֶȫϱ޶ֻʹñ
                foreach (TableColumn column in mainColumns) {
                    column.Name = MAIN_TABLE_ALIAS + "." + column.Name;
                }

                // ӱֶ
                TableColumnCollection subColumns = SubTableDAL.TableColumns;
                //// ɾӱֶ
                //subColumns.Remove(SubTableDAL.TablePrimaryColumn);
                // ӱֶȫϱ޶ֻʹñ
                foreach (TableColumn column in subColumns) {
                    column.Name = SUB_TABLE_ALIAS + "." + column.Name;
                }
                mainColumns.AddRange(subColumns);
                return mainColumns;
            }
        }

        //internal override T BuildEntity(MySql.Data.MySqlClient.MySqlDataReader reader, int startIndex) {
        //    throw new Exception("The method or operation is not implemented.");
        //}

    }
}
