using System;
using System.Collections.Generic;
using System.Text;
using MySql.Data.MySqlClient;
using System.Data;

namespace FunTonn.MySqlDAL.SqlUtility {

    /// <summary>
    /// ݱʳ࣬ṩֻݱͼķ
    /// </summary>
    /// <typeparam name="T">ʵ</typeparam>
    public abstract class ReadonlyTableAccess<T> : IReadonlyTableAccess {

        //private TableColumnCollection _tableColumns = null;

        /// <summary>
        /// ȡݱ
        /// </summary>
        abstract public string TableName { get;}

        /// <summary>
        /// ݱҪִвѯ޸ĵȶֶ
        /// </summary>
        abstract public TableColumnCollection TableColumns { get;}

        /// <summary>
        /// ʹһѾ򿪵DataReaderݱеһݶȡ䵽һʵ
        /// </summary>
        /// <param name="reader"></param>
        /// <param name="startIndex">ƫѯֱӴò</param>
        /// <returns></returns>
        abstract internal T BuildEntity(MySqlDataReader reader, int startIndex);

        /// <summary>
        /// ȡݱĬΪݱĵһֶΣֵΪnull
        /// </summary>
        virtual public TableColumn TablePrimaryColumn { 
            get {
                try {
                    return TableColumns[0];
                } catch (Exception) {
                    return null;
                }
            } 
        }

        /// <summary>
        /// ȡʽ
        /// </summary>
        virtual protected string OrderExpress { get { return null; } }

        /// <summary>
        /// ȡһֵֵָʾǷ񻺴ѯ
        /// ֻ GetAll() Ч
        /// </summary>
        virtual protected bool UseCache { get { return false; } }

        /// <summary>
        /// ûĴȡKEYֻе UseCache Ϊ true ʱЧ
        /// </summary>
        virtual protected string CacheKey { get { return TableName.ToUpper(); } }

        /// <summary>
        /// SELECTWHERE֮ǰӾ
        /// </summary>
        /// <returns></returns>
        virtual protected string BuildSelectString() {
            StringBuilder sb = new StringBuilder();
            sb.Append("select ");
            for (int i = 0; i < TableColumns.Count; i++) {
                if (i > 0)
                    sb.Append(',');
                sb.AppendFormat("{0}", TableColumns[i].Name);
            }
            sb.AppendFormat(
                " from {0} ", TableName
                );
            
            return sb.ToString();
        }

        /// <summary>
        /// ʹָSQLȡ
        /// </summary>
        /// <param name="cmd"></param>
        /// <returns></returns>
        virtual protected IList<T> ReadData(string cmd) {
            List<T> result = new List<T>();
            using (MySqlDataReader reader = DBUtility.ExecuteReader(CommandType.Text, cmd, null)) {
                while (reader.Read()) {
                    result.Add(BuildEntity(reader, 0));
                }
            }
            return result.AsReadOnly();
        }

        /// <summary>
        /// ֵȡӦļ¼У
        /// ֵΪ null
        /// </summary>
        /// <param name="value"></param>
        /// <returns></returns>
        /// <exception cref="System.ArgumentNullException">δָʱ쳣</exception>
        public T GetByPrimaryKey(object value) {
            if (TablePrimaryColumn == null)
                throw new NotSupportedException(" TablePrimaryColumn Ϊ null ʱ÷֧֡");  //ArgumentNullException("TablePrimaryColumn", "TablePrimaryColumn can not be null.");

            string paramName = "?keyValue";
            string sql = string.Format(
                "{0} where {1}={2}",
                BuildSelectString(),
                TablePrimaryColumn.Name,
                paramName
                );

            using (MySqlDataReader reader = DBUtility.ExecuteReader(CommandType.Text, sql, new MySqlParameter(paramName, value))) {
                if (reader.Read()) {
                    return BuildEntity(reader, 0);
                }
                return default(T);
            }
        }

        public IList<T> GetAll() { 
            // TODO: ʹCache
            int itemCount = 0;
            return SearchTable(null, null, null, null, out itemCount);
        }

        public IList<T> Search(SearchConditionCollection filter) {
            int itemCount = 0;
            return SearchTable(filter, null, null, null, out itemCount);
        }

        public IList<T> Search(SearchConditionCollection filter, string order) {
            int itemCount = 0;
            return SearchTable(filter, order, null, null, out itemCount);
        }

        public IList<T> Search(SearchConditionCollection filter, int pageSize, int pageIndex, out int itemCount) {
            return SearchTable(filter, null, pageSize, pageIndex, out itemCount);
        }

        public IList<T> Search(SearchConditionCollection filter, string order, int pageSize, int pageIndex, out int itemCount) {
            return SearchTable(filter, order, pageSize, pageIndex, out itemCount);
        }

        // ȡ
        private IList<T> SearchTable(SearchConditionCollection filter, string order, int? pageSize, int? pageNumber, out int itemCount) {
            itemCount = -1;
            bool paging = pageSize != null; // Ƿҳ
            string select = BuildSelectString();
            string where = filter == null ? string.Empty : filter.ToString(); // whereӾ
            string cmd = select; // Ĳѯҳ
            if (where != string.Empty) {
                cmd = select + " where " + where;
            }

            // 
            string userOrder = BuildOrderString(order);
            if (userOrder != null) {
                // Ĳѯи
                cmd += userOrder;
            }

            // ҳ
            if (paging) {
                // 㵱ǰѯڲҳµļ¼
                string sqlCount = string.Format(
                    "select count(*) from {0}{1}",
                    TableName, filter == null ? string.Empty : " where " + filter.ToString()
                    );
                itemCount = Convert.ToInt32(DBUtility.ExecuteScalar(CommandType.Text, sqlCount, null));
                // Ĳѯиӷҳ
                cmd += BuildPagingString(itemCount, (int)pageSize, (int)pageNumber);
            }

            //System.Diagnostics.Trace.WriteLine(cmd);
            // ȡ
            return ReadData(cmd);
        }

        private string BuildPagingString(int itemCount, int pageSize, int pageNumber) {
            // ҳ
            double divide = itemCount / pageSize;
            double floor = System.Math.Floor(divide);
            if (itemCount % pageSize != 0)
                floor++;
            int pc = Convert.ToInt32(floor);
            int num = 0;
            
            if (pageNumber > pc)
                pageNumber = pc;
            if (pageNumber < 1)
                pageNumber = 1;

            num = (pageNumber - 1) * pageSize;

            return string.Format(
                " limit {0},{1} ",
                num, pageSize
                );
        }

        private string BuildOrderString(string userOrder) {
            string prefix = " order by ";
            if (userOrder == null) {
                if (OrderExpress != null)
                    return prefix + OrderExpress;
                else
                    return null;
            }
            return prefix + userOrder;
        }


    }
}
