using System;
using System.Collections.Generic;
using System.Text;

namespace FunTonn.MySqlDAL.SqlUtility {

    /// <summary>
    /// SQLѯ
    /// </summary>
    public sealed class SearchCondition {

        //private readonly string _column;
        //private readonly ColumnComparison[] _comparisons;
        private readonly string _clause; // ѯӾ

        private SearchCondition() { } // For test only

        /// <summary>
        /// ʵһµ SearchCondition 󣬲ʹָĲѯӾ䴴ѯ
        /// </summary>
        /// <param name="clause">ʽ {field} {operator} {value} "field1 = 'somevalue'"</param>
        public SearchCondition(string clause) {
            _clause = clause;
        }

        /// <summary>
        /// ʵһµ SearchCondition 
        /// </summary>
        /// <param name="column">ֶ</param>
        /// <param name="comparison">Ƚ</param>
        public SearchCondition(string column, ColumnComparison comparison) {
            if (string.IsNullOrEmpty(column)) {
                _clause = null;
            } else {
                try {
                    _clause = GetClause(column, SqlLogic.Or, new ColumnComparison[] { comparison });
                } catch (Exception) {
                    throw;
                }
            }
        }

        /// <summary>
        /// ʵһµ SearchCondition 
        /// </summary>
        /// <param name="column">ֶ</param>
        /// <param name="logic">ֶбȽ֮Ĵ߼</param>
        /// <param name="comparisons">Ƚ</param>
        public SearchCondition(string column, SqlLogic logic, params ColumnComparison[] comparisons) {
            if (string.IsNullOrEmpty(column)) {
                _clause = null;
            } else {
                try {
                    _clause = GetClause(column, logic, comparisons);
                } catch(Exception){
                    throw;
                }
            }
        }

        ///// <summary>
        ///// ȡǰѯõֶ
        ///// </summary>
        //public string Column {
        //    get { return _column; }
        //}

        ///// <summary>
        ///// ȡǰֶҪõıȽļ
        ///// </summary>
        //public ColumnComparison[] Comparisons {
        //    get { return _comparisons; }
        //}

        private string GetClause(string column, SqlLogic logic, ColumnComparison[] comparisons) {
            if (comparisons == null)
                throw new ArgumentNullException("comparisons");
            if (comparisons.Length < 1)
                throw new ArgumentOutOfRangeException("comparisons", "List must bigger than 1.");
            StringBuilder sb = new StringBuilder();
            int i = 0;
            foreach (ColumnComparison cc in comparisons) {
                if (i > 0)
                    sb.Append(logic == SqlLogic.Or ? " or " : " and ");
                sb.AppendFormat(cc.ToString(), column);
                i++;
            }
            return " ( " + sb.ToString() + " ) ";
        }

        /// <summary>
        /// WHEREӾ
        /// </summary>
        /// <returns></returns>
        public override string ToString() {
            return _clause;
        }

        private void Test() {
            SearchCondition sc = new SearchCondition("field1", SqlLogic.And,
                new ColumnComparison(SqlOperator.Like, "w", "f", "y", "f", "n"),
                new ColumnComparison(SqlOperator.NotIn, 'g','u')
                );
                
            Console.WriteLine(sc.ToString());
        }


        

    }
}
