using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace FunTonn.MySqlDAL.SqlUtility {

    public class SearchConditionCollection : IList<SearchCondition> {

        IList<SearchCondition> list = new List<SearchCondition>();

        #region IList<SearchCondition> Members

        public int IndexOf(SearchCondition item) {
            return list.IndexOf(item);
        }

        public void Insert(int index, SearchCondition item) {
            list.Insert(index, item);
        }

        public void RemoveAt(int index) {
            list.RemoveAt(index);
        }

        public SearchCondition this[int index] {
            get {
                return list[index];
            }
            set {
                list[index] = value;
            }
        }

        #endregion

        #region ICollection<SearchCondition> Members

        public void Add(SearchCondition item) {
            if (list.Contains(item)) {
                throw new ArgumentException("Item already added.", "item");
            }
            list.Add(item);
        }

        public void Clear() {
            list.Clear();
        }

        public bool Contains(SearchCondition item) {
            return list.Contains(item);
        }

        void ICollection<SearchCondition>.CopyTo(SearchCondition[] array, int arrayIndex) {
            list.CopyTo(array, arrayIndex);
        }

        public int Count {
            get { return list.Count; }
        }

        bool ICollection<SearchCondition>.IsReadOnly {
            get { return list.IsReadOnly; }
        }

        public bool Remove(SearchCondition item) {
            return list.Remove(item);
        }

        #endregion

        #region IEnumerable<SearchCondition> Members

        public IEnumerator<SearchCondition> GetEnumerator() {
            return list.GetEnumerator();
        }

        #endregion

        #region IEnumerable Members

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator() {
            throw new System.Exception("The method or operation is not implemented.");
        }

        #endregion

        /// <summary>
        /// SQLʹõSQLѯַ
        /// ֱַͨӸWHERE֮
        /// </summary>
        /// <returns></returns>
        public override string ToString() {
            if (list.Count < 1)
                return " 1=1 ";
            StringBuilder sb = new StringBuilder(" 1=1 ");
            string s = null;
            foreach (SearchCondition condition in list) {
                s = condition.ToString();
                if (!string.IsNullOrEmpty(s)) {
                    sb.Append(" and ");
                    sb.Append(condition.ToString());
                }
            }
            return sb.ToString();
        }

    }
}
